#ifndef _BININF_HPP
#define _BININF_HPP

#include "common.h"

//checks if current IDA input file conforms to an ELF format, functions return 0 if false, 1 if true and -1 in case of errors
int is_elf();
int is_elf_32bit();
int is_elf_64bit();
//get architecture name respective current IDA input file, arg arch has to point to 8 byte char array, the terminating 
//zero of the return string may be absent if the processor name is too long, returns -1 in case of errors
int get_architecture(char arch[8]);
//get arm abi version respective to current IDA input file, returns -1 in case of errors or if input file doesn't 
//conform to elf for arm 32bit (arg abi in these cases left undefined), if arm abi not identifiable returns "unknown", arg abi has to point to 128 byte char array
//(supported 32 bit arm abi versions: "Pre-v4", "v4", "v4T", "v5T", "v5TE", "v5TEJ", "v6", "v6KZ", "v6T2", "v6K", "v7")
int elf32arm_getarmabi(char abi[128]);

#endif  _BININF_HPP