/*basic socket and file io, database io*/

#ifndef _FSDBIO_HPP
#define _FSDBIO_HPP

#include "common.h"

#include <diskio.hpp>
#include <pro.h>
#include <fpro.h>
#include <windows.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <stdlib.h>
#include <stdio.h>
#include <pronet.h> 

//establishes connections to module-defined db shards, returns - 1 in case of errors and number of connections otherwise
int mysql_establish_connections();
//has to be called after establish_connections() and activitiy funcs to clean up the connections
int mysql_terminate_connections();
//returns - 1 in case of errors, out arg natlib_primkey_generated returns db-auto-generated primary key of new db entry hin which generated primary keys of db entry,
//out arg db_shard returns the number of the shard the entry was stored in (based on numfuncs)
int mysql_store_natlibdata(char *appname, char *libpath, unsigned int numfuncs, std::string *abi, unsigned int *db_shard, unsigned int *natlib_primkey_generated);
//returns -1 in case of errors, caller specifies shard via argument, and the primary key of the repective native lib the funtion belongs tohas to (used to write foreign key)
int mysql_store_natfuncdata(std::string *funcname, double cenx, double ceny, double cenz, double cenw,
	double cendashx, double cendashy, double cendashz, double cendashw, unsigned int db_shard, unsigned int natlib_primkey);

//file io, IDA SDK
FILE *file_open_append(char *fpath);
//reads the byte contents of a file, returns -1 in case of errors and the number of read bytes otherwise
long file_readbytecontents(char *fpath, char *buffer);
void file_close(FILE *fp); //in case of failures displays a message and exits
void file_write_str(FILE *fp, char *str); //in case of failures displays a message and exits

//socket io
int setup_client_socket(char * server, char * server_port, SOCKET* out_sock);
int send_buf_via_socket(SOCKET* sock, char* buf);
int shutdown_socket(SOCKET* sock);

#endif  _FSDBIO_HPP