#ifndef _CFGTOOLS_HPP
#define _CFGTOOLS_HPP

#include "common.h"

//calculates nodes of a cfg dfs-reachable from root and their immdom tree (array repres., cooper's algorithm)
void analyze_dominance(qvector<qbasic_block_t>  *cfg_blocks, int *immdoms, bool* reachable_nodes, int *num_nodes_reachable);
/*appends an exit node to the blocks of a cfg which are dfs-reachable from root*/
int append_exitnode(qflow_chart_t *cfg, bool *dfs_reachable_from_root);
//calculates on a cfg with last block = appended exit node rev. dfs-reachability and if reachability from 
//exit is same as reachability from root builds postdom tree, otherwise returns -1 and postdom tree not built 
int analyze_postdominance_from_exitnode(qvector<qbasic_block_t>  *cfg_blocks, bool * dfs_reachable_from_root, int *postdoms, bool* revdfs_reachable_from_exit, int *num_nodes_revdfs_reachable_from_exit);
//calculates order of branches in a cfg by 1.) num nodes, 2.) num instructs, 3.) binary value of first statement,
//df-crawls starting at branch start nodes and stopping before all "stopnodes" and the branching post dominator
int calculate_branchorder(qvector<qbasic_block_t> *blocks, qvector<int> *branch_startnodes, int *stopnodes, int branching_postdom, qvector<int> *branch_startnodes_ordered);
//counts the number of instructions and calls in a cfg basic block
int count_basicblock_instructions(qbasic_block_t* block, int *num_instr, int *num_calls);


#endif  _CFGTOOLS_HPP